      subroutine write_inputs( base_name, mx,
     &                         tempz, temp, cwz, cw, hwz, hw, qz, q,
     &                         rho, press, theta, bvfsq,
     &                         time_meas_p, y_meas_p, z_meas_p,
     &                         time_meas_s, y_meas_s, z_meas_s,
     &                         time_meas_cir_p, cir_meas_p,
     &                         time_meas_cir_s, cir_meas_s,
     &                         time_model,
     &                         y_model_p, z_model_p, cir_model_p,
     &                         y_model_s, z_model_s, cir_model_s,
     &                         y0, z0, v0, b0, gam0, zmf,
     &                         ac_speed, hw_avg, ntemp, ncw, nhw, nq,
     &                         nt_meas_p, nt_meas_s, 
     &                         nt_meas_cir_p, nt_meas_cir_s,
     &                         nt_model,
     &                         linear )

      implicit none 

      real   y_meas_p(mx),  z_meas_p(mx), cir_meas_p(mx),
     &       y_meas_s(mx),  z_meas_s(mx), cir_meas_s(mx),
     &     time_meas_p(    mx), time_meas_s(    mx),
     &     time_meas_cir_p(mx), time_meas_cir_s(mx),
     &        tempz(mx), temp(mx), cwz(mx), cw(mx), bvfsq(mx), rho(mx),
     &         hwz(mx),   hw(mx),  qz(mx),  q(mx), theta(mx), press(mx),
     &        time_model(mx), 
     &        y_model_p( mx), z_model_p(mx), cir_model_p(mx),
     &        y_model_s( mx), z_model_s(mx), cir_model_s(mx),
     &        y0, z0, v0, b0, gam0, zmf, ac_speed, scale_time, 
     &        scale_circ, scale_z, hw_avg, t_fac, t_lag, tan3, pi
      integer mx, ntemp, ncw, nhw, nq,
     &        nt_meas_p, nt_meas_s, nt_meas_cir_p, nt_meas_cir_s,
     &        nt_model,
     &        linear
      character(80) base_name 
      
      real    plot_time_min, plot_time_max, plot_z_min, plot_z_max,
     &        plot_cir_min, plot_cir_max, plot_N_min, plot_N_max,
     &        plot_edr_min, plot_edr_max, plot_temp_min, plot_temp_max,
     &        plot_wind_min, plot_wind_max, plot_Ns_min, plot_Ns_max,
     &        plot_edrs_min, plot_edrs_max, vort_z_min, vort_z_max,
     &        plot_winds_min, plot_winds_max, z_min, z_max, bvf,
     &        data_time_min, data_time_max, plot_y_min, plot_y_max,
     &        model_time_min, model_time_max, vort_y_min, vort_y_max,
     &        eps, t_star, t_die, t_max, g_star, A_0, A_1, edr_star,
     &        N2_star, N_star, edr_star_avg, N_star_avg, g_star_0, c13,
     &        z_avg, z_bot, t_scale, sum3

      integer i, itime_tick, iy_tick, iz_tick, icir_tick,
     &        iedr_tick, iN_tick, itemp_tick, iwind_tick, isamp,
     &        iedrs_tick, iNs_tick, iwinds_tick, i_start, i_stop

      pi = acos(-1.0)
      c13 = 1.0/3.0

c   *** Compute min and max values for use in setting the plotting limits

      vort_y_max    =  0.0
      vort_y_min    =  1.0e+10
      vort_z_max    =  0.0
      vort_z_min    =  1.0e+10
      data_time_max =  0.0
      data_time_min =  1.0e+10

      do i=1, nt_meas_p
         vort_y_min    = min( vort_y_min,       y_meas_p(i) )
         vort_y_max    = max( vort_y_max,       y_meas_p(i) )
         vort_z_min    = min( vort_z_min,       z_meas_p(i) )
         vort_z_max    = max( vort_z_max,       z_meas_p(i) )
         data_time_min = min( data_time_min, time_meas_p(i) )
         data_time_max = max( data_time_max, time_meas_p(i) )
      end do

      do i=1, nt_meas_s
         vort_y_min    = min( vort_y_min,       y_meas_s(i) )
         vort_y_max    = max( vort_y_max,       y_meas_s(i) )
         vort_z_min    = min( vort_z_min,       z_meas_s(i) )
         vort_z_max    = max( vort_z_max,       z_meas_s(i) )
         data_time_min = min( data_time_min, time_meas_s(i) )
         data_time_max = max( data_time_max, time_meas_s(i) )
      end do

      do i=1, nt_meas_cir_p
         data_time_min = min( data_time_min, time_meas_cir_p(i) )
         data_time_max = max( data_time_max, time_meas_cir_p(i) )
      end do

      do i=1, nt_meas_cir_s
         data_time_min = min( data_time_min, time_meas_cir_s(i) )
         data_time_max = max( data_time_max, time_meas_cir_s(i) )
      end do

      model_time_max = time_model(nt_model)

      if( index(base_name,'IGE') .ne. 0 .or.
     &    data_time_max .eq. 0.0 ) then
         plot_time_max = max( data_time_max, model_time_max )
      else
         plot_time_max = data_time_max
      end if

c      plot_z_min = max( vort_z_min, zmf*b0 )
c      plot_z_min = zmf*b0      ! for OGE
      plot_z_min = vort_z_min   ! to see all of the data
c      plot_z_min = 0.0          ! to see the ground
      plot_z_max = max( vort_z_max, z0 )
      plot_y_min = vort_y_min
      plot_y_max = vort_y_max

c   *** Adjust the lower z limit to capture the model results too

      do i=1, nt_model
         if( time_model(i) .le. plot_time_max ) then
            plot_y_min = min( plot_y_min, y_model_p(i), y_model_s(i) )
            plot_y_max = max( plot_y_max, y_model_p(i), y_model_s(i) )
            plot_z_min = min( plot_z_min, z_model_p(i), z_model_s(i) )
         end if
      end do

c      print *, 'plot_time_max, plot_z_min = ', plot_time_max, plot_z_min
c      print *, 'vort_y_min, vort_y_max, plot_y_min, plot_y_max = ',
c     &           vort_y_min, vort_y_max, plot_y_min, plot_y_max

      plot_cir_max = -1.0e+10
      plot_cir_min =  1.0e+10

      do i=1, nt_meas_cir_p
         if( time_meas_cir_p(i) .le. plot_time_max ) then
            plot_cir_min = min( plot_cir_min, cir_meas_p(i) )
            plot_cir_max = max( plot_cir_max, cir_meas_p(i) )
         end if
      end do

      do i=1, nt_meas_cir_s
         if( time_meas_cir_s(i) .le. plot_time_max ) then
            plot_cir_min = min( plot_cir_min, cir_meas_s(i) )
            plot_cir_max = max( plot_cir_max, cir_meas_s(i) )
         end if
      end do

      do i=1, nt_model
         if( time_model(i) .le. plot_time_max ) then
            plot_cir_min = min( plot_cir_min, cir_model_s(i),
     &                          abs(cir_model_p(i)) )
            plot_cir_max = max( plot_cir_max, cir_model_s(i),
     &                          abs(cir_model_p(i)) )
         end if
      end do

      if( index(base_name,'IGE') .ne. 0 ) then
        plot_z_min   =    0.0
        plot_z_max   =   90.0
        plot_cir_min =    0.0
        plot_y_min   = -100.0
        plot_y_max   =  400.0
      end if

      plot_N_max    = -1.0e+10
      plot_N_min    =  1.0e+10
      plot_edr_max  = -1.0e+10
      plot_edr_min  =  1.0e+10
      plot_temp_max = -1.0e+10
      plot_temp_min =  1.0e+10
      plot_wind_max = -1.0e+10
      plot_wind_min =  1.0e+10

      do i=1, ntemp
         if( tempz(i) .ge. plot_z_min .and. 
     &       tempz(i) .le. plot_z_max       ) then
            bvf = bvfsq(i)/abs(bvfsq(i)+1.0e-12)*sqrt(abs(bvfsq(i)))
            plot_N_min    = min( plot_N_min,    bvf )
            plot_N_max    = max( plot_N_max,    bvf )
            plot_edr_min  = min( plot_edr_min,  q(i) )
            plot_edr_max  = max( plot_edr_max,  q(i) )
            plot_temp_min = min( plot_temp_min, temp(i) )
            plot_temp_max = max( plot_temp_max, temp(i) )
         end if
      end do

      do i=1, nhw
         if( hwz(i) .ge. plot_z_min .and.
     &       hwz(i) .le. plot_z_max       ) then
            plot_wind_min = min( plot_wind_min, hw(i) )
            plot_wind_max = max( plot_wind_max, hw(i) )
         end if
      end do

      do i=1, ncw
         if( cwz(i) .ge. plot_z_min .and.
     &       cwz(i) .le. plot_z_max       ) then
            plot_wind_min = min( plot_wind_min, cw(i) )
            plot_wind_max = max( plot_wind_max, cw(i) )
         end if
      end do

c   *** Adjust the plotting limits so they are multiples of nice numbers.

      itime_tick = 20
      itime_tick = 1
      iy_tick = 20
      iy_tick = 1
      iz_tick = 20
      iz_tick = 1
      icir_tick = 50
      icir_tick = 2
      iN_tick = 1.0e-3
      eps = 1.0e-6

      plot_time_max = ( int(plot_time_max-eps)/itime_tick + 1 )*
     &                float(itime_tick)
      plot_y_min = ( int(plot_y_min    )/iy_tick     )*float(iy_tick)
      plot_y_max = ( int(plot_y_max-eps)/iy_tick + 1 )*float(iy_tick)
      plot_z_min = ( int(plot_z_min    )/iz_tick     )*float(iz_tick)
      plot_z_max = ( int(plot_z_max-eps)/iz_tick + 1 )*float(iz_tick)
      plot_cir_min = ( int(plot_cir_min    )/icir_tick     )*
     &               float(icir_tick)
      plot_cir_max = ( int(plot_cir_max-eps)/icir_tick + 1 )*
     &               float(icir_tick)
      
c   *** Write a file to be used in constructing the plots

      open(unit=9,file='Output/'//trim(base_name)//'.limits')
      write(9,9) trim(base_name), temp(1), b0, v0, z0,
     &           plot_time_max, plot_y_min, plot_y_max,
     &           plot_z_min, plot_z_max, plot_cir_min, plot_cir_max
9     format('CASE = ',a30,/,
     &       'T0 = ',f8.1,/,
     &       'B0 = ',f8.3,/,
     &       'V0 = ',f8.3,/,
     &       'Z0 = ',f8.3,/,
     &       'TMAX = ',f6.1,/,
     &       'YMIN = ',f6.1,/,
     &       'YMAX = ',f6.1,/,
     &       'ZMIN = ',f6.1,/,
     &       'ZMAX = ',f6.1,/,
     &       'CIRMIN = ',f6.1,/,
     &       'CIRMAX = ',f6.1 )
      close(9)

c   *** Write various files for the input data

      scale_time = (v0/b0)
      scale_circ = 1.0/(2.0*pi*b0*V0)
      scale_z    = 1.0/b0
      close(19)
      close(20)
      open(unit=19,file='Output/circ_star.dat',access='append')
      open(unit=20,file='Output/z_star.dat',access='append')

      open(unit=10,file='Output/'//trim(base_name)//'.meas_yz_p')

      write(10,110)
110   format('#    time        y_p         z_p')
      t_fac = 1.0 - hw_avg/ac_speed
      tan3 = tan(3.0/180.0*pi)
      do i=1, nt_meas_p
         write(10,40) time_meas_p(i), y_meas_p(i), z_meas_p(i)
40       format(1p,6e12.4)
         t_lag = time_meas_p(i)*t_fac
         write(20,40) t_lag*scale_time,
     &      (z_meas_p(i)+hw_avg*tan3*t_lag-z0)*scale_z
      end do
      close(10)

      open(unit=11,file='Output/'//trim(base_name)//'.meas_yz_s')

      write(11,111)
111   format('#    time        y_s         z_s')
      do i=1, nt_meas_s
         write(11,40) time_meas_s(i), y_meas_s(i), z_meas_s(i)
         t_lag = time_meas_s(i)*t_fac
         write(20,40) t_lag*scale_time,
     &      (z_meas_s(i)+hw_avg*tan3*t_lag-z0)*scale_z
      end do
      close(11)

      open(unit=12,file='Output/'//trim(base_name)//'.meas_cir_p')

      write(12,112)
112   format('#    time       cir_p')
      do i=1, nt_meas_cir_p
         write(12,40) time_meas_cir_p(i), cir_meas_p(i)
         write(19,40) time_meas_cir_p(i)*t_fac*scale_time,
     &                cir_meas_p(i)*scale_circ
      end do
      close(12)

      open(unit=13,file='Output/'//trim(base_name)//'.meas_cir_s')

      write(13,113)
113   format('#    time       cir_s')
      do i=1, nt_meas_cir_s
         write(13,40) time_meas_cir_s(i), cir_meas_s(i)
         write(19,40) time_meas_cir_s(i)*t_fac*scale_time,
     &                cir_meas_s(i)*scale_circ
      end do
      close(13)
      close(19)

c      z_min = zmf*b0            ! to see profiles down to bottom of OGE
c      z_min = vort_z_min        ! to see profiles down to lowest vortex pos
      z_min = 0.0
c      z_max = plot_z_max
c      z_max = max( z0, vort_z_max )
      z_max = plot_z_max

      open(unit=14,file='Output/'//trim(base_name)//'.meas_cw')

      do i=1, ncw
         if( cwz(i) .gt. z_max ) goto 202
      end do
202   i_stop = min( i, ncw )
      do i=ncw, 1, -1
         if( cwz(i) .lt. z_min ) goto 203
      end do
203   i_start = max( i, 1 )

      write(14,114)
114   format('#     z       cross wind')
      if( ncw .eq. 2 .and. cw(1) .eq. cw(2) ) then
         write(14,40) z_min, cw(1)
         write(14,40) z_max, cw(2)
      else
         do i=i_start, i_stop
            write(14,40) cwz(i), cw(i)
         end do
      end if
      close(14)

      open(unit=15,file='Output/'//trim(base_name)//'.meas_hw')

      do i=1, nhw
         if( hwz(i) .gt. z_max ) goto 204
      end do
204   i_stop = min( i, nhw )
      do i=nhw, 1, -1
         if( hwz(i) .lt. z_min ) goto 205
      end do
205   i_start = max( i, 1 )

      write(15,115)
115   format('#     z       head wind')
      if( nhw .eq. 2 .and. hw(1) .eq. hw(2) ) then
         write(15,40) z_min, hw(1)
         write(15,40) z_max, hw(2)
      else
         do i=i_start, i_stop
            write(15,40) hwz(i), hw(i)
         end do
      end if
      close(15)

      open(unit=16,file='Output/'//trim(base_name)//'.meas_edr')

      do i=1, nq
         if( qz(i) .gt. z_max ) goto 206
      end do
206   i_stop = min( i, nq )
      do i=nq, 1, -1
         if( qz(i) .lt. z_min ) goto 207
      end do
207   i_start = max( i, 1 )

      write(16,116)
116   format('#     z       eddy dissipation rate')
      if( nq .eq. 2 .and. q(1) .eq. q(2) ) then
         write(16,40) z_min, q(1)
         write(16,40) z_max, q(2)
      else
         do i=i_start, i_stop
            write(16,40) qz(i), q(i)
         end do
      end if
      close(16)

      open(unit=17,file='Output/'//trim(base_name)//'.meas_state')

      do i=1, ntemp
         if( tempz(i) .gt. z_max ) goto 210
      end do
210   i_stop = min( i, ntemp )
      do i=ntemp, 1, -1
         if( tempz(i) .lt. z_min ) goto 211
      end do
211   i_start = max( i, 1 )

      write(17,117)
117   format('#     z          rho          p           T         ',
     &       'theta        N^2')
      do i=i_start, i_stop
         write(17,40) tempz(i), rho(i), press(i), temp(i), theta(i),
     &                bvfsq(i)
      end do
      close(17)

c   *** Write the linear model for circulation for reference

      open(unit=20,file='Output/'//trim(base_name)//'.lin')

      t_scale = v0/b0
      z_bot = 1.5*b0

      sum3 = 0.0
      isamp = 0
      do i=1, nq
         if( z_bot .le. qz(i) .and. qz(i) .le. z0 ) then
            edr_star = ((q(i)*b0)**c13)/v0
            sum3 = sum3 + edr_star
            isamp = isamp + 1
         end if
      end do
      if( isamp .eq. 0 ) then
         edr_star_avg = ((q(1)*b0)**c13)/v0
      else
         edr_star_avg = sum3/float(isamp)
      end if

      sum3 = 0.0
      isamp = 0
      do i=1, ntemp
         if( z_bot .le. tempz(i) .and. tempz(i) .le. z0 ) then
            N2_star = bvfsq(i)*(b0/v0)**2
            N_star = N2_star/abs(N2_star+1.0e-12)*
     &               sqrt(abs(N2_star))
            sum3 = sum3 + N_star
            isamp = isamp + 1
         end if
      end do
      if( isamp .eq. 0 ) then
         N2_star = bvfsq(1)*(b0/v0)**2
         N_star_avg = N2_star/abs(N2_star+1.0e-12)*
     &                sqrt(abs(N2_star))
      else
         N_star_avg = sum3/float(isamp)
      end if

      g_star_0 = 1.0
      A_0 = -0.102
      A_1 = A_0 - 0.687*edr_star_avg + 0.048*N_star_avg

c      print *, 'edr_star_avg, N_star_avg, A1 = '
c      print *,  edr_star_avg, N_star_avg, A_1

      t_die = 1 - ( g_star_0 + A_0 )/A_1
      t_max = min( t_die, time_model(nt_model)*t_scale )

      write(20,40) 0.0, g_star_0
      t_star = 1.0
      write(20,40) t_star, g_star_0 + A_0*t_star
      t_star = t_max
      write(20,40) t_star, g_star_0 + A_0 + A_1*(t_star-1.0)

      close(20)

      return
      end
